// testBSTRClient.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "tchar.h"
#include "..\..\testBSTRRules\testBSTRRules.h"
#include "..\..\testBSTRRules\testBSTRRules_i.c"
int main(int argc, char* argv[])
{
	CoInitialize(NULL);

	HRESULT hRes;
	IBSTRTest* pTestBstr;
	hRes = CoCreateInstance(CLSID_BSTRTest,NULL,CLSCTX_INPROC_SERVER,IID_IBSTRTest,(void**)&pTestBstr);
	if(SUCCEEDED(hRes))
	{
		//rule 1
		{
			BSTR bstrParam = SysAllocString(L"Test");
			if(SUCCEEDED(pTestBstr->SomeMethodRule1(bstrParam)))
			{
			  //use bstrParam
  			}
			//done.. Now free..
			SysFreeString(bstrParam);
		}

		//rule 2
		{
			BSTR bstrParam = SysAllocString(L"Test");
			if(SUCCEEDED(pTestBstr->SomeMethodRule2(&bstrParam)))
			{
			  //use bstrParam
			  MessageBox(NULL,bstrParam,_T("New value"),MB_OK);
			}
			//done.. Now free..
			SysFreeString(bstrParam);
		}

		//rule 3
		{
			BSTR bstrParam;
			if(SUCCEEDED(pTestBstr->SomeMethodRule3(&bstrParam)))
			{
			  //use bstrParam
			  MessageBox(NULL,bstrParam,_T("New value"),MB_OK);

			  //Done.. Now free..
			  SysFreeString(bstrParam);
			}
		}

		pTestBstr->Release();
	}
	CoUninitialize();
	return 0;
}
